\section{Introduction}


\begin{frame}[label={sec:introduction-fil-rouge}]{Introduction}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Exemple fil rouge}
\begin{itemize}
\item Tout le long du cours on utilise un seul language
cpp de la formation gitlab
\begin{itemize}
    \item https://gitlab.inria.fr/sed-rennes/formations/formation-gitlab-ci
\end{itemize}

pour le deploiement on fait une image docker déploiée dans les différentes registry (ex: dockerhub, gthub, giltab registry, allgo) (cool car on boot strap avec la section optimization des installations d'outils pour les CI) 

on aura probablement besoin d'une branche par type de CI
\end{itemize}
\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:introduction}]{Introduction}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{TODO}
\begin{itemize}
\item A quoi ca sert.
\item Differentes phases:

    tests unitaires
    tests fonctionels
    tests d’intégrations

\item Offres disponibles à l’Inria (CDASH, Gitlab-CI, Jenkins, Github actions)

    TODO regarder les autres tutelles : ex: CNRS koda.cnrs.fr , INSA,

\end{itemize}
\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:introduction-definitions}]{Introduction}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{CI Definitions}
\begin{itemize}
\item In software engineering, continuous integration (CI) is the practice of merging all developers' working copies to a shared mainline several times a day. 
\hspace*{0pt}\hfill \emph{Wikipedia}
%https://en.wikipedia.org/wiki/Continuous_integration

\item CI is the practice of automating the integration of code changes from multiple contributors into a single software project. It’s a primary DevOps best practice, allowing developers to frequently merge code changes into a central repository where builds and tests then run. Automated tools are used to assert the new code’s correctness before integration.

%A source code version control system is the crux of the CI process. The version control system is also supplemented with other checks like automated code quality tests, syntax style review tools, and more.  
\hspace*{0pt}\hfill \emph{Documentation Atlassian}
% https://www.atlassian.com/continuous-delivery/continuous-integration

\end{itemize}
\end{block}
\begin{block}{CI/CD Definitions}
\begin{itemize}
\item CI/CD bridges the gaps between development and operation activities and teams by enforcing automation in building, testing and deployment of applications. CI/CD services compile the incremental code changes made by developers, then link and package them into software deliverables.

Automated tests verify the software functionality, and automated deployment services deliver them to end users.
\hspace*{0pt}\hfill \emph{Wikipedia}  



\end{itemize}
\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:introduction-definitions-CD}]{CD}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{CD ? continuous delivery or continuous deployment ? }

According to wikipedia : (more often) continuous delivery or (less often) continuous deployment

delivery = potentially capable of being deployed but are actually not deployed

%https://en.wikipedia.org/wiki/Continuous_deployment

In short: continuous delivery is a subset of continuous deployment $\ddot\smile$



\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}




\begin{frame}[label={sec:introduction-what}]{Introduction}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{What is Continuous Integration ?}
\begin{itemize}
\item Technique puissante permettant dans le cadre du développement d’un logiciel en équipes de:
Garder en phase les équipes de dév
Limiter risques de dérive 
Limiter la complexité

\item A intervalles réguliers, vous allez construire (build) et tester la dernière version de votre logiciel.

\item Parrallèlement, chaque développeur teste et valide (commit) son travail en ajoutant son code dans un lieu de stockage unique.



\end{itemize}
\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}


\begin{frame}[label={sec:introduction-why}]{Why CI/CD ?}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Why CI/CD ?}
\begin{itemize}
    \item increase early defect discovery
    \item increase productivity
    \item provide faster release cycles
    \item support modern-day DevOps practices involving continuous development, continuous testing, continuous integration, continuous deployment and continuous monitoring of software applications
    \item help produce reproducible artifact (with limitation, only with carefully designed scripts)
    
\end{itemize}
\end{block}

%\begin{block}{Why CI/CD ?}


%The aim is to increase early defect discovery, increase productivity, and provide faster release cycles. The process contrasts with traditional methods where a collection of software updates were integrated into one large batch before deploying the newer version. Modern-day DevOps practices involve continuous development, continuous testing, continuous integration, continuous deployment and continuous monitoring of software applications throughout its development life cycle. The CI/CD practice, or CI/CD pipeline, forms the backbone of modern day DevOps operations. 
%https://en.wikipedia.org/wiki/CI/CD

%\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}

\begin{frame}[label={sec:introduction-why-2}]{Why CI/CD ?}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Automation}
Help development team with their repetitive and error-prone tasks
\begin{itemize}
    \item \textbf{Automated builds:} CI/CD services can automatically build and compile code changes as they are committed to a repository. This helps ensure that code changes are correctly built and packaged for deployment.

    \item \textbf{Automated testing:} CI/CD services can automatically run tests on code changes as they are committed to a repository. This helps identify problems with code changes early in the development process. This includes traditional tests but also all the verification that can be done on the project ( code quality, syntax style review, documentation quality, dependency check, vulnerability check, intellectual property check,...)

    \item \textbf{Deployment automation:} CI/CD services can automate the process of deploying code changes to various environments, such as staging or production servers. This helps ensure that code changes are quickly and consistently deployed to the appropriate environments.

    \item \textbf{Workflow automation:} CI/CD services can automate various tasks in the software development process, such as code reviews, issue tracking, and project management. This helps developers work more efficiently and effectively.
\end{itemize}
\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}


\begin{frame}[label={sec:introduction-how-2}]{How CI/CD ?}
%------------------------------------------ diapo -----------------------------------------------
\begin{block}{Main features}

A source code version control system is the crux of the CI process.  
% main feature
\begin{figure}
\centering
\begin{tikzpicture}[
node distance=0.5cm and 0.5cm,
roundnode/.style={circle, draw=green!60, fill=green!5, very thick, minimum size=7mm},
squarednode/.style={rectangle, draw=red!60, fill=red!5, very thick, minimum size=5mm},
roundedsquarednode/.style={rectangle, 
    draw=red!60, 
    fill=red!5, 
    rounded corners = 5pt, 
    very thick, 
    minimum size=5mm},
roundedsquarednode2/.style={rectangle, 
    draw=red!60, 
    fill=red!5, 
    rounded corners = 20pt, 
    very thick, 
    minimum size=5mm},
]



%Nodes
\node[roundedsquarednode]   (scm)                               {Version control system};
\node[roundedsquarednode]   (notification)      [above=of scm]  {Notification system};
\node[roundedsquarednode]   (test)              [right=of scm]  {Test system};
\node[roundedsquarednode]   (build)             [below=of scm]  {Build system};
\node[roundedsquarednode]   (deploy)            [left=of scm]   {Deployment system};

%Rectangles
\begin{scope}[on background layer]
\node[draw, thick, inner xsep=0.1em, inner ysep=0.1em, 
    rounded corners = 15pt,
    fit=(scm) (notification) (test) (build) (deploy)] (box) {};

\end{scope}


%Lines
%\draw[-] (scm.south) -- (build.north);
%\draw[->] (maintopic.east) -- (rightsquare.west);
%\draw[->] (rightsquare.south) .. controls +(down:7mm) and +(right:7mm) .. (lowercircle.east);
\end{tikzpicture}
\end{figure}

\end{block}

%------------------------------------------------------------------------------------------------
\end{frame}


\begin{frame}[label={sec:introduction-how-3}]{How CI/CD ?}

\begin{block}{Main components}
%main components
\begin{figure}
\centering

\begin{tikzpicture}[
roundnode/.style={circle, draw=green!60, fill=green!5, very thick, minimum size=7mm},
squarednode/.style={rectangle, draw=red!60, fill=red!5, very thick, minimum size=5mm},
shadowsquarednode/.style={rectangle, 
    draw=blue!100, 
    very thick, 
    top color= blue!60, bottom color=white!100, 
    minimum size=5mm,
    blur shadow     = {shadow blur steps = 15}},
]
%Nodes
\node[squarednode]      (orchestrator)                           {Orchestrator};
\node[squarednode]      (front)         [left=of orchestrator]  {FrontEnd};
\node[shadowsquarednode]      (runner)        [below=of orchestrator]  {Runner(s)};

%Lines
\draw[->] (orchestrator.south) -- (runner.north);
\draw[->] (orchestrator.west) -- (front.east);
%\draw[->] (rightsquare.south) .. controls +(down:7mm) and +(right:7mm) .. (lowercircle.east);
\end{tikzpicture}

\end{figure}

\end{block}
%------------------------------------------------------------------------------------------------
\end{frame}


\begin{frame}[label={sec:introduction-use-case}]{Use Case : developer submit a modification}
%------------------------------  diapo ----------------------------------------------------------
\begin{figure}
\centering

\begin{tikzpicture}[
]
%\node[inner sep=0pt] (devlabtop1)
\node[inner sep=0pt] (devlabtop3) at (30pt,40pt)
    {\includegraphics[width=.15\textwidth]{images/intro_use_case/dev_labtop.png}};
\node[inner sep=0pt] (devlabtop2) at (15pt,20pt)
    {\includegraphics[width=.15\textwidth]{images/intro_use_case/dev_labtop.png}};
\node[inner sep=0pt] (devlabtop1) at (0pt,0pt)
    {\includegraphics[width=.15\textwidth]{images/intro_use_case/dev_labtop.png}};
\node[below right] at (devlabtop1.south west) {Developers};

\node[inner sep=0pt] (scmserver) at (120pt,0)
    {\includegraphics[width=.15\textwidth]{images/intro_use_case/scm_server.png}};
\node[below right] at (scmserver.south west) {SCM};
    
\node[inner sep=0pt] (prodserver) at (240pt,10pt)
    {\includegraphics[width=.15\textwidth]{images/intro_use_case/rack_server.png}};
\node[below right] at (prodserver.south west) {Production server};
    
\node[inner sep=0pt] (qualifserver) at (250pt,70pt)
    {\includegraphics[width=.15\textwidth]{images/intro_use_case/rack_server.png}};
\node[below right] at (qualifserver.south west) {Qualification server};
    
\node[inner sep=0pt] (testserver) at (240pt,130pt)
    {\includegraphics[width=.10\textwidth]{images/intro_use_case/server.png}};
\node[below right] at (testserver.south west) {Test server};

\node[inner sep=0pt] (ciserver) at (140pt,100pt)
    {\includegraphics[width=.10\textwidth]{images/intro_use_case/server.png}};
\node[below] at (ciserver.south) {CI server};

\draw[->, out=20,in=-20, distance=-0.5cm]   (ciserver.south west) to node[font=\scriptsize]{ (1) Monitor changes} (scmserver.north west);

\pause

\draw[->] (devlabtop1.east) -- (scmserver.west) node[draw=none,fill=none,font=\scriptsize,midway,below] { (2) Commit}; 

\pause

\draw[->,out=20,in=-20]   (scmserver.north east) to node[font=\scriptsize]{ (3) Update/Push} (ciserver.south east);

\pause

\path (ciserver.north) edge [min distance=50mm, in=50,out=-130, loop above]  node[font=\scriptsize]{(4) Build + Test} (ciserver.north);

\node[above, yshift=25pt, inner sep=0,outer sep=0] at (devlabtop3.north) (console){
  \tikz {
	\filldraw[draw=lightgray,fill=black] (0pt,120pt) rectangle (115pt,200pt);
	}
};

\draw[blue]   ([yshift=5pt]ciserver.south west) -- (console.south west);
\draw[blue]   (ciserver.north west) -- (console.north east);

\pause

\node[text=lightgray, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (console.north west) (gcc){> gcc --c *.c -o test\\ Compiling...};
\node[text=green, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (gcc.south west) (gccok){Compilation Succefull};

\pause

\node[text=lightgray, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (gccok.south west) (testing){Testing...\\ Junit test ...};
\node[text=green, align=left, anchor=south west,font=\scriptsize, inner sep=2, outer sep=0] at (testing.south east) {OK};

\node[text=lightgray, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (testing.south west) (integrationtest){Integration tests...};
\node[text=green, align=left, anchor=south west,font=\scriptsize, inner sep=2, outer sep=0] at (integrationtest.south east) {OK};

\node[text=lightgray, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (integrationtest.south west) (perftest){Performance tests...};
\node[text=green, align=left, anchor=south west,font=\scriptsize, inner sep=2, outer sep=0] at (perftest.south east) {OK};

\node[text=lightgray, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (perftest.south west) (inspection){Code Inspection...};
\node[text=yellow, align=left, anchor=south west,font=\scriptsize, inner sep=2, outer sep=0] at (inspection.south east) {86\%};


\pause

\node[text=lightgray, align=left, anchor=north west,font=\scriptsize, inner sep=2, outer sep=0] at (inspection.south west) (deploy){Deploying in test environment...};
\node[text=green, align=left, anchor=south west,font=\scriptsize, inner sep=2, outer sep=0] at (deploy.south east) {OK};

\draw[->, green, out=10,in=230] (ciserver.north east) to node[draw=none,fill=none,font=\scriptsize,midway,below] { (5) Deployment} (testserver.west) ; 


\pause

\draw[->, red, out=250,in=30]   (ciserver.west) to node[font=\scriptsize, above, near end]{ (6) Notification} (devlabtop3.north);

\end{tikzpicture}

\end{figure}

%------------------------------------------------------------------------------------------------
\end{frame}